// Y@u@դpC
// Delphi 7 Enterprise
// Windows XP PRO with SP2
// 2007/11/19
// Reference :
//   http://topic.csdn.net/t/20010925/20/302688.html

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

{$R *.dfm}

function   GetGroupList(var   list:TStringList)   :   boolean;

  //Y@u@դpCC
  //ѼơGconst   groupName   :   String   u@զW
  //             var   list   :   TStringList   
  //^ȡGpG\opCA^true;   
  //                 pGѡA^false   
  function   GetPcList(const   groupName:string;   var   list:TStringList)   :   boolean;   

  //ھڭpWoIPa}   
  function   GetIP(const   pcName:String):string;   
    
  implementation
    
  uses   
          winsock;   
    
  type   
          TNetResourcePtr   =   ^TNetResource;   
    
  function   GetGroupList(var   list:TStringList)   :   boolean;   
  var   
          buf   :   pointer;   
          bufSize   :   dword;   
          i   :   integer;   
          hRes   :   Thandle;   
          p   :   TNetResourcePtr;   
          ret   :   dword;   
          count   :   dword;   
  begin   
          //oڸ`I
          ret   :=   WnetOpenEnum(RESOURCE_GLOBALNET,RESOURCETYPE_ANY,RESOURCEUSAGE_CONTAINER,NIL,hRes);
          if   ret<>NO_ERROR   then   
          begin   
                  GetGroupList   :=   false;   
                  exit;       //ѡA^false   
          end;   
    
//          count   :=   $ffffff;
//          bufSize   :=   4096;
//          GetMem(buf,bufSize);
          ret   :=   WNetEnumResource(hRes,count,buf,bufSize);
          if   (ret<>NO_ERROR)   or   (count<1)   then
          begin   //ѩΪ0Ӷ
                  GetGroupList   :=   false;   
                  freeMem(buf);
                  WnetCloseEnum(hRes);
                  exit;
          end;

          //oڸ`I   ^TNetResource
          p   :=   TNetResourcePtr(buf);

          //C|   
          wNetCloseEnum(hRes);

          //}sC|   
          ret   :=   WNetOpenEnum(RESOURCE_GLOBALNET,RESOURCETYPE_ANY,RESOURCEUSAGE_CONTAINER,@(p^),hRes);
          if   ret<>NO_ERROR   then   
          begin
                  GetGroupList   :=   false;
                  freeMem(buf);
                  exit;
          end;
    
          //u@զC   
          count   :=   $ffffffff;   
          bufSize   :=   4096;   
          GetMem(buf,bufSize);   
    
          ret   :=   wNetEnumResource(hRes,count,buf,bufSize);   
          if   (ret<>NO_ERROR)   or   (count<1)   then   
          begin       //ѩΪ0Ӷ
                  GetGroupList   :=   false;   
                  wNetCloseEnum(hRes);   
                  freeMem(buf);   
                  exit;   
          end;   
    
          p   :=   TNetResourcePtr(buf);   
          list.clear;

          for   i:=0   to   count-1   do   
          begin   
                  list.add(p^.lpRemoteName);   
                  inc(p);   
          end;   
    
          freeMem(buf);   
          wNetCloseEnum(hRes);   
    
          GetGroupList   :=   true;   
            
  end;   
    
  function   GetPcList(const   groupName:string;   var   list:TStringList)   :   boolean;   
  var   
          buf   :   pointer;   
          bufSize   :   dword;   
          i   :   integer;   
          hRes   :   Thandle;   
          p   :   TNetResourcePtr;   
          ret   :   dword;   
          count   :   dword;   
          pcName   :   string;   
  begin   
          //ˬdO_Xu@զWr   
          if   length(groupName)<1   then   
          begin   
                  getPcList   :=   false;   
                  exit;   
          end;   
    
          //]m   p   
          new(p);   
          p^.dwScope   :=   RESOURCE_GLOBALNET;   
          p^.dwType   :=   RESOURCETYPE_ANY;   
          p^.dwUsage   :=   RESOURCEUSAGE_CONTAINER;   
          p^.lpRemoteName   :=   pchar(groupName);   
    
          //}C|   
          ret   :=   WNetOpenEnum(RESOURCE_GLOBALNET,RESOURCETYPE_ANY,RESOURCEUSAGE_CONTAINER,@(p^),hRes);   
          if   ret<>NO_ERROR   then   
          begin   
                  getPcList   :=   false;   
                  dispose(p);   
                  exit;   
          end;   
    
          //}lC|pWr   
          count   :=   $ffffffff;   
          bufSize   :=   4096;   
          getMem(buf,bufSize);
          ret   :=   WNetEnumResource(hRes,count,buf,bufSize);   
          if   (ret<>NO_ERROR)   or   (count<1)   then   
          begin   
                  freeMem(buf);   
                  WNetCloseEnum(hRes);   
                  dispose(p);   
                  getPcList   :=   false;   
                  exit;
          end;

          dispose(p);   //   add
          //pC
          p   :=   TNetResourcePtr(buf);
          list.Clear;   
          for   i:=0   to   count-1   do   
          begin   
                  pcName   :=   p^.lpRemoteName;   
                  list.add(copy(pcName,3,length(pcName)-2));   
                  inc(p);   
          end;   
    
          freeMem(buf);   
          WnetCloseEnum(hRes);   
          //dispose(p);     o̥XDAҥHF   :(   
          getPcList   :=   true;   
            
  end;   
    
  function   GetIP(const   pcName:string)   :   string;   
  var   
          WSAData:   TWSAData;   
          HostEnt:   PHostEnt;   
  begin   
          HostEnt   :=   nil;   
          WSAStartup(2,   WSAData);   
          HostEnt   :=   gethostbyname(PChar(pcName));   
          if   HostEnt   <>   nil   then   
          begin   
              with   HostEnt^   do   
                  GetIP:=   Format('%d.%d.%d.%d',   [Byte(h_addr^[0]),   Byte(h_addr^[1]),   Byte(h_addr^[2]),Byte(h_addr^[3])]);   
          end
          else   
                  GetIP   :=   '';   
          WSACleanup;   
  end;

procedure TForm1.FormCreate(Sender: TObject);
var
  GroupList : TStringList;
  i : Integer;
begin
  Memo1.Clear;
  if GetGroupList(GroupList) then
  begin
    for i:=0 to GroupList.Count -1 do
    begin
      Memo1.Lines.Add(GroupList.Strings[i]);
    end;
  end;
  Memo1.Lines.Add('Finish !');
end;

end.
